﻿#target photoshop

/*
* Botched by Frood
* todo:
*	 - try to get a replacement for ugly getSelecedLayers() "trick" which seems to be in fact a design flaw by Adobe
*/

/*
@@@BUILDINFO@@@ Layers to Channels.jsx 0.1
*/

/*
<javascriptresource>
<name>Layers to Channels</name>
<about>Creates channels from selected layers (e.g. render masks) and removes them. Creates separate channels for R/G/B if they are not equal.&#13;&#10;&#13;&#10;v0.1 - Botched by Frood 2020</about>
<menu>automate</menu>
<category>Rakete</category>
<enableinfo>in(PSHOP_ImageMode, RGBMode, RGB48Mode, RGB96Mode)</enableinfo>
</javascriptresource>
*/

var begDesc = "$$$/JavaScripts/Layers to Channels/Description=Creates channels from selected layers (e.g. render masks) and removes them. Creates separate channels for R/G/B if they are not equal." // endDesc
var begName = "$$$/JavaScripts/Layers to Channels/MenuName=Layers to Channels" // endName
//app.displayDialogs = DialogModes.NO;

function hasDifferentRGBChannels () {
    var equal=true;
    var histR=activeDocument.channels[0].histogram;
    var histG=activeDocument.channels[1].histogram;
    var histB=activeDocument.channels[2].histogram;
    var i = histR.length
    while (i--) {
            if ((histR[i]!=histG[i]) || (histR[i]!=histB[i]) || (histG[i]!=histB[i])) return true;
        }
    return false;
 }

function hideAllLayers() {
    for (var i=0; i<app.activeDocument.layers.length;i++) {
        app.activeDocument.layers[i].visible=false;
    }
}
function showAllLayers() {
    for (var i=0; i<app.activeDocument.layers.length;i++) {
        app.activeDocument.layers[i].visible=true;
    }
}

function getSelectedLayers() {
        var resultLayers=new Array();
        var idGrp = stringIDToTypeID( "groupLayersEvent" );
        var descGrp = new ActionDescriptor();
        var refGrp = new ActionReference();
        refGrp.putEnumerated(charIDToTypeID( "Lyr " ),charIDToTypeID( "Ordn" ),charIDToTypeID( "Trgt" ));
        descGrp.putReference(charIDToTypeID( "null" ), refGrp );
        try {
            executeAction( idGrp, descGrp, DialogModes.NO );
         }
        catch(e) {
            //alert(e);
            alert
            alert("Please select one or more layers.","Layers to Channels");
            return resultLayers;
        }
        for (var ix=0;ix<app.activeDocument.activeLayer.layers.length;ix++){resultLayers.push(app.activeDocument.activeLayer.layers[ix])}
        var id8 = charIDToTypeID( "slct" );
        var desc5 = new ActionDescriptor();
        var id9 = charIDToTypeID( "null" );
        var ref2 = new ActionReference();
        var id10 = charIDToTypeID( "HstS" );
        var id11 = charIDToTypeID( "Ordn" );
        var id12 = charIDToTypeID( "Prvs" );
        ref2.putEnumerated( id10, id11, id12 );
        desc5.putReference( id9, ref2 );
        executeAction( id8, desc5, DialogModes.NO );
        return resultLayers;
    }   

function createChannel(channelsToCopy) {
    if (channelsToCopy==undefined) {
        app.activeDocument.activeLayer.copy();
        var newC=app.activeDocument.channels.add();
        newC.name=app.activeDocument.activeLayer.name;
        app.activeDocument.paste();
        app.activeDocument.activeChannels=[app.activeDocument.channels[0],app.activeDocument.channels[1],app.activeDocument.channels[2]];
 }
else {
    for (i in channelsToCopy) {
        var c=app.activeDocument.channels[i];
        app.activeDocument.activeChannels=[c];
        app.activeDocument.activeLayer.copy();
        var newC=app.activeDocument.channels.add();
        newC.name=app.activeDocument.activeLayer.name+"."+c.name;
        app.activeDocument.paste();
        app.activeDocument.activeChannels=[app.activeDocument.channels[0],app.activeDocument.channels[1],app.activeDocument.channels[2]];
      }
  }
}

function main() {
    for (layer in layers) {
        $.write ("Processing layer '" + layers[layer].name+ "'\n");
        hideAllLayers();
        app.activeDocument.activeLayer=layers[layer];
        layers[layer].visible=true;

        if (hasDifferentRGBChannels()) {
            $.write("Will split into R/G/B channels.\n");
            createChannel([app.activeDocument.channels[0],app.activeDocument.channels[1],app.activeDocument.channels[2]])
        }
        else {
            $.write("Grayscale layer - will create single channel.\n");
            createChannel();
        }
        layers[layer].remove();
    }
    showAllLayers();
}


// get (user)-selected layers to process:
var layers = getSelectedLayers();

if (layers.length) {
    $.writeln("Will turn " + layers +" into Channels.");
    app.activeDocument.suspendHistory("Layers to Channels", "main()");
}
else {
    $.writeln("No layers selected.");
}
